<template>
  <div class="application-preview">
    <div class="application-top">
      <span>{{ application.organization.name }}</span>
      <div class="application-top__actions">
        <p>{{ application.event.title }}</p>
        <v-btn
          color="blue"
          variant="contained-flat"
          size="small"
          @click="$refs.vue3SimpleHtml2pdf.download()"
        >
          <v-icon color="white" aria-hidden="false"> mdi-chevron-down </v-icon>
          Скачать
        </v-btn>
      </div>
    </div>
    <vue3-simple-html2pdf
      ref="vue3SimpleHtml2pdf"
      :options="pdfOptions"
      :filename="`application-${application.id}`"
    >
      <div class="application-bottom">
        <h3>{{ application.organization.name }}</h3>
        <p>"{{ application.event.title }}"</p>
        <div class="application-organisation">
          <p>{{ application.template.general_title }}</p>
          <img
            class="seal"
            :src="application.template.seal.url.full_size"
            alt=""
          />
          <img
            class="sign"
            :src="application.template.sign.url.full_size"
            alt=""
          />
        </div>
      </div>
    </vue3-simple-html2pdf>
  </div>
</template>

<script>
export default {
  name: "ApplicationPreview",

  props: {
    application: {
      type: Object,
    },
  },

  data() {
    return {
      pdfOptions: {
        margin: 6,
        image: {
          type: "jpeg",
          quality: 1,
        },
        html2canvas: { scale: 3 },
        jsPDF: {
          unit: "mm",
          format: "a7",
          orientation: "p",
        },
      },
    };
  },
};
</script>

<style scoped lang="scss">
.application {
  &-preview {
    width: 220px;
    height: 310px;
    border-radius: 4px 4px;
    position: relative;
  }
  &-top {
    position: absolute;
    width: 100%;
    height: 100%;
    z-index: 5;
    background-color: rgba(0, 0, 0, 0.3);
    > span {
      padding: 4px 10px;
      background-color: $white;
      font-weight: 400;
      font-size: 9px;
      line-height: 12px;
      color: #2891c9;
      border-radius: 4px;
      position: absolute;
      top: 8px;
      left: 8px;
    }
    &__actions {
      position: absolute;
      bottom: 8px;
      left: 8px;
      width: calc(100% - 16px);
      > p {
        font-weight: 500;
        font-size: 14px;
        line-height: 18px;
        color: #ffffff;
        margin: 0 0 $base-space * 2;
      }
      > button {
        width: 100%;
      }
    }
  }
  &-bottom {
    width: 220px;
    height: 310px;
    background: url("../assets/application.png") no-repeat center center;
    background-size: contain;
    position: relative;
    > h3 {
      font-family: "Comic Sans MS", sans-serif;
      color: #123079;
      font-style: normal;
      font-weight: 400;
      font-size: 12px;
      line-height: 12px;
      position: absolute;
      width: 80%;
      top: 115px;
      left: 20px;
      text-align: center;
    }
    > p {
      font-family: "Comic Sans MS", sans-serif;
      color: #123079;
      font-style: normal;
      font-weight: 400;
      font-size: 12px;
      line-height: 12px;
      position: absolute;
      width: 80%;
      top: 170px;
      left: 25px;
      text-align: center;
    }
  }
  &-organisation {
    position: absolute;
    top: 210px;
    left: 40px;
    width: 100%;
    display: flex;
    align-items: center;
    > p {
      font-family: "Comic Sans MS", sans-serif;
      color: #123079;
      font-style: normal;
      font-weight: 400;
      font-size: 10px;
      line-height: 12px;
      position: absolute;
    }
  }
}

.seal {
  width: 30px;
  position: relative;
  left: 100px;
}
.sign {
  width: 30px;
  position: relative;
  top: 15px;
  left: 50px;
}
</style>
